diff --git a/res/res_pjsip_pidf_eyebeam_body_supplement.c b/res/res_pjsip_pidf_eyebeam_body_supplement.c
index cc6dfd1..fcf1919 100644
--- a/res/res_pjsip_pidf_eyebeam_body_supplement.c
+++ b/res/res_pjsip_pidf_eyebeam_body_supplement.c
@@ -60,11 +60,11 @@ static void add_eyebeam(pj_pool_t *pool, pj_xml_node *node, const char *pidfstat
 
 	if (pidfstate[0] != '-') {
 		pj_xml_node *activities = ast_sip_presence_xml_create_node(pool, status, "ep:activities");
-		size_t str_size = sizeof("ep:") + strlen(pidfstate);
+		struct ast_str *act_str = ast_str_alloca(strlen("ep:") + strlen(pidfstate) + 1);
 
-		activities->content.ptr = pj_pool_alloc(pool, str_size);
-		activities->content.slen = pj_ansi_snprintf(activities->content.ptr, str_size,
-				"ep:%s", pidfstate);
+		ast_str_append(&act_str, 0, "ep:%s", pidfstate);
+
+		ast_sip_presence_xml_create_node(pool, activities, ast_str_buffer(act_str));
 	}
 
 	ast_sip_presence_xml_create_attr(pool, node, XMLNS_PP, XMLNS_PERSON);
